﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import flash.events.MouseEvent;
	import com.as3facile.DefaultButton;
	import flash.filters.ColorMatrixFilter;
	import com.gskinner.geom.ColorMatrix;
	import flash.display.LoaderInfo;
	import flash.display.Loader;
	import flash.events.IOErrorEvent;
	import flash.net.URLRequest;
	import flash.events.ProgressEvent;
	import flash.events.Event;
	import flash.display.Sprite;
	
	import com.demonsters.debugger.MonsterDebugger;

	import com.actionscriptfacile.ui.text.UITextField;
	
	
	public class Main extends Sprite
	{
		private var oTxtProgress : UITextField;
		
		private var oImageContent : Loader;
		
		private var oTxtSaturationInput : UITextField;
		private var oTxtBrillanceInput : UITextField;
		private var oTxtContrasteInput : UITextField;
		private var oTxtColorInput : UITextField;
		
		
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			this.setupUI();				
		}

		
		/**
		 * Préparation de l'interface utilisateur.
		 * 
		 */
		private function setupUI() : void
		{
			oTxtProgress = this.addText("Chargement en cours...");
			this.addChild(oTxtProgress);
			oTxtProgress.x = 34;
			
			// chargement d'une image
			oImageContent = new Loader();
			
			var oLoaderInfo:LoaderInfo = oImageContent.contentLoaderInfo;
			oLoaderInfo.addEventListener(Event.COMPLETE, onLoadComplete);
			oLoaderInfo.addEventListener(ProgressEvent.PROGRESS, onLoadProgress);
			oLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onLoadError);
			
			//oImageContent.load(new URLRequest("logo-flash.png"));
			oImageContent.load(new URLRequest("http://www.actionscript-facile.com/wp-content/uploads/2012/03/logo-flash.png"));
		}
		
		
		/**
		 * Progression du chargement du fichier image.
		 * 
		 */
		private function onLoadProgress(event : ProgressEvent) : void
		{
			var nProgress:Number = Math.round( event.target.bytesLoaded * 100 / event.target.bytesTotal );
			oTxtProgress.text = "Chargement en cours : "+String(nProgress)+" %";
			//MonsterDebugger.trace(this, "Chargement en cours : "+String(nProgress)+" %");
		}
		
		
		/**
		 * En cas d'erreur de chargement.
		 * 
		 */
		private function onLoadError(event : IOErrorEvent) : void
		{
			MonsterDebugger.trace(this, "onLoadError");
			MonsterDebugger.trace(this, event);
			oTxtProgress.text = "Erreur de chargement de l'image !!!";
		}
		
		
		/**
		 * Chargement du fichier SVG terminé.
		 * 
		 */
		private function onLoadComplete(event : Event) : void
		{
			MonsterDebugger.trace(this, "onLoadComplete");
			//MonsterDebugger.trace(this, event);
			
			oTxtProgress.text = "Création de l'affichage en cours...";

			//var oImageContent:Loader = event.target.loader;
			this.addChild(oImageContent);
			oImageContent.x = (stage.stageWidth - oImageContent.width) /2;
			oImageContent.y = oTxtProgress.y + oTxtProgress.height;
			
			this.addControl();
		}

		
		/**
		 * Ajout des contrôles de brillance, saturation, contraste et teinte sur l'image.
		 * 
		 */
		private function addControl() : void
		{
			// réglage de la saturation
			var oTxtSaturation:UITextField = this.addText("Saturation :");
			oTxtSaturation.x = oImageContent.x;
			oTxtSaturation.y = oImageContent.y + oImageContent.height + 24;
			this.addChild(oTxtSaturation);
			
			oTxtSaturationInput = this.addText("0");
			oTxtSaturationInput.addEventListener(Event.CHANGE, onChangeFilters);
			oTxtSaturationInput.x = oTxtSaturation.x + oTxtSaturation.width;
			oTxtSaturationInput.y = oTxtSaturation.y;
			oTxtSaturationInput.convertToInput();
			oTxtSaturationInput.selectable = true;
			this.addChild(oTxtSaturationInput);
			
			// réglage de la brillance
			var oTxtBrillance:UITextField = this.addText("Brillance :");
			oTxtBrillance.x = oTxtSaturationInput.x + oTxtSaturationInput.width + 103;
			oTxtBrillance.y = oTxtSaturationInput.y;
			this.addChild(oTxtBrillance);
			
			oTxtBrillanceInput = this.addText("0");
			oTxtBrillanceInput.addEventListener(Event.CHANGE, onChangeFilters);
			oTxtBrillanceInput.x = oTxtBrillance.x + oTxtBrillance.width;
			oTxtBrillanceInput.y = oTxtBrillance.y;
			oTxtBrillanceInput.convertToInput();
			oTxtBrillanceInput.selectable = true;
			this.addChild(oTxtBrillanceInput);
			
			// réglage du contraste
			var oTxtContraste:UITextField = this.addText("Contraste :");
			oTxtContraste.x = oTxtSaturation.x;
			oTxtContraste.y = oTxtBrillance.y + oTxtBrillance.height;
			this.addChild(oTxtContraste);
			
			oTxtContrasteInput = this.addText("0");
			oTxtContrasteInput.addEventListener(Event.CHANGE, onChangeFilters);
			oTxtContrasteInput.x = oTxtContraste.x + oTxtContraste.width;
			oTxtContrasteInput.y = oTxtContraste.y;
			oTxtContrasteInput.convertToInput();
			oTxtContrasteInput.selectable = true;
			this.addChild(oTxtContrasteInput);
			
			// réglage de la couleur
			var oTxtColor:UITextField = this.addText("Couleur :");
			oTxtColor.x = oTxtBrillance.x;
			oTxtColor.y = oTxtContrasteInput.y;
			this.addChild(oTxtColor);
			
			oTxtColorInput = this.addText("0");
			oTxtColorInput.addEventListener(Event.CHANGE, onChangeFilters);
			oTxtColorInput.x = oTxtColor.x + oTxtColor.width;
			oTxtColorInput.y = oTxtContrasteInput.y;
			oTxtColorInput.convertToInput();
			oTxtColorInput.selectable = true;
			this.addChild(oTxtColorInput);
			
			var oBtnStart:DefaultButton = new DefaultButton();
			oBtnStart.getObject().label = "Reset !";
			oBtnStart.getObject().x = oImageContent.x;
			oBtnStart.getObject().y = oTxtContrasteInput.y + oTxtContrasteInput.height + 13;
			oBtnStart.getObject().addEventListener ( MouseEvent.CLICK, onResetValue );
			this.addChild(oBtnStart);
			
			this.updateFilters();
			
			oTxtProgress.text = "Renseignez des valeurs pour modifier les filtres l'image.";
		}


		/**
		 * Mets à jour les filtres de l'image à chaque modification du texte.
		 * 
		 */
		private function onChangeFilters(event : Event) : void
		{
			this.updateFilters();
		}
		
		
		/**
		 * Mets à jour les filtres sur l'image.
		 * 
		 */
		private function updateFilters() : void
		{
			var oColorMatrix:ColorMatrix = new ColorMatrix();
			oColorMatrix.adjustColor(Number(oTxtBrillanceInput.text), Number(oTxtContrasteInput.text), Number(oTxtSaturationInput.text), Number(oTxtColorInput.text));
			oImageContent.filters = [new ColorMatrixFilter(oColorMatrix)];
		}

		
		/**
		 * Suppression des effets.
		 * 
		 */
		private function onResetValue(event : MouseEvent) : void
		{
			oTxtBrillanceInput.text = oTxtSaturationInput.text = oTxtContrasteInput.text = oTxtColorInput.text = "0";
			this.updateFilters();
		}
		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("size", 13);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0X006f77);// changement de la couleur
			
			return oTxtField;	 
		}
		

	}
}
